package com.InitialImmortal.initial.client.gui;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;

public class HudGui extends GuiScreen {
    public HudGui(Minecraft mc) { this.mc = mc; }
    
    public void draw() {
        drawPanel(3, 2, 30, 12, 128 << 24, 100 << 24);
        drawPanel(3, 15, 30, 12, 128 << 24, 100 << 24);
        
        drawPanel(34, 2, 100, 12, 128 << 24, 100 << 24);
        NBTTagCompound data = mc.player.getEntityData();
        
        String LEVEL = !data.hasKey("LEVEL") ? "无" : data.getString("LEVEL");
        String LittleLEVEL = !data.hasKey("littleLEVEL") ? "无" : data.getString("littleLEVEL");
        drawCenteredString(mc.fontRenderer, "§l" + LEVEL, 12, 4, 0x64ffffff);
        drawCenteredString(mc.fontRenderer, "§l" + LittleLEVEL, 12, 17, 0x64ffffff);
        
        EntityPlayerSP player = mc.player;
        double health = (player.getHealth() / player.getMaxHealth());
        drawPanel(35, 3, (int)(98.0D * health), 7, 0xffff0000, 0x64ff6464);
        drawPanel(35, 8, (int)(98.0D * health), 5, 0xff7d0000, 0xff7d0a0a);
        drawCenteredString(mc.fontRenderer, "§l" + player.getHealth() + "/" + player.getMaxHealth(), 60, 3, 0x64ffffff);
        
        drawPanel(34, 15, 100, 6, 128 << 24, 100 << 24);
        drawPanel(34, 21, 100, 6, 128 << 24, 100 << 24);
        
        double powerMax = data.getDouble("powermax");
        double power = data.getDouble("power");
        
        drawPanel(35, 16, (int)(98.0D * power / powerMax), 3, 0xff00ffff, 0x6400ffff);
        drawPanel(35, 19, (int)(98.0D * power / powerMax), 1, 0xff00bfbf, 0x6400bfbf);
        
        double baseMax = data.getDouble("basemax");
        double base = data.getDouble("base");
        drawPanel(35, 22, (int)(98.0D * base / baseMax), 3, 0xffffff00, 0xffffff00);
        drawPanel(35, 25, (int)(98.0D * base / baseMax), 1, 0xffd9d900, 0xffd9d900);
    }
    
    public static void drawPanel(int x, int y, int width, int height, int color, int color2) {
        drawRect(x, y, x + width, y + height, color);
        drawRect(x, y, x + width, y + 1, color2);
        drawRect(x, y + 1, x + 1, y + height, color2);
        drawRect(x, y + height - 1, x + width, y + height, color2);
        drawRect(x + width - 1, y, x + width, y + height, color2);
    }
}