package com.InitialImmortal.initial.event;

import com.InitialImmortal.initial.helper.AttributeHelper;
import com.InitialImmortal.initial.network.Message;
import com.InitialImmortal.initial.network.MessageRegister;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.IAttribute;
import net.minecraft.entity.ai.attributes.IAttributeInstance;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTBase;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.items.ItemStackHandler;

@EventBusSubscriber
public class MainEvent {
  @SubscribeEvent
  public static void onLivingUpdateEvent(LivingEvent.LivingUpdateEvent event) {
    EntityLivingBase entityLiving = event.getEntityLiving();

    NBTTagCompound tag = entityLiving.getEntityData();
    if (tag.hasKey("attribute")) {
      String[] array = tag.getString("attribute").split("-");
      if(array.length == 3) {
        double level = Double.parseDouble(array[1]);
        IAttribute attribute = switchAttribute(array[0]);
        IAttributeInstance instance = entityLiving.getEntityAttribute(attribute);
        if(instance != null) {
          boolean is = array[2].equals("true");
          if (is)
            level += instance.getAttributeValue();
          instance.setBaseValue(level);
        }
        tag.removeTag("attribute");
      }
    }

    if (entityLiving instanceof EntityPlayerMP) {
      EntityPlayerMP player = (EntityPlayerMP)entityLiving;
      MessageRegister.instance.sendTo(new Message(player.getEntityData()), player);
      for (int i = 0; i < player.inventory.getSizeInventory(); i++) {
        ItemStack stack = player.inventory.getStackInSlot(i);
        tag = stack.getTagCompound();
        if (tag != null) {
          if(tag.hasKey("ItemAttribute")) {
            String[] array = tag.getString("ItemAttribute").split("-");
            if(array.length == 5) {
              int level = Integer.parseInt(array[1]);
              String name = array[0];
              boolean is = array[2].equals("true");
              int slot = Integer.parseInt(array[3]);
              int type = Integer.parseInt(array[4]);
              if (is)
                level = (int) (level + AttributeHelper.getMCAttributeValue(stack, name));
              AttributeHelper.setItemAttribute(stack, AttributeHelper.AttributeNameReplaceSecond(name), level, slot, type);
              tag.removeTag("ItemAttribute");
              //stack.setTagCompound(tag);
            }
          }
          if (tag.hasKey("container")) {
            String[] array = tag.getString("container").split("-");
            if(array.length == 2) {
              String name = array[0];
              int slot = Integer.parseInt(array[1]);

              ItemStackHandler handler = new ItemStackHandler(slot * 9);

              tag.setBoolean("hasContainer", true);
              tag.setTag("itemContainer", handler.serializeNBT());
              tag.setInteger("line", slot);
              tag.setString("name", name);

              tag.removeTag("container");

              //stack.setTagCompound(tag);
            }
          }
        }
      }
    }
  }

  private static IAttribute switchAttribute(String name) {
    switch (name) {
      case "ATTACK_DAMAGE":
        return SharedMonsterAttributes.ATTACK_DAMAGE;
      case "MOVEMENT_SPEED":
        return SharedMonsterAttributes.MOVEMENT_SPEED;
      case "ARMOR":
        return SharedMonsterAttributes.ARMOR;
      case "ARMOR_TOUGHNESS":
        return SharedMonsterAttributes.ARMOR_TOUGHNESS;
      case "ATTACK_SPEED":
        return SharedMonsterAttributes.ATTACK_SPEED;
      case "MAX_HEALTH":
        return SharedMonsterAttributes.MAX_HEALTH;
    }
    return SharedMonsterAttributes.LUCK;
  }
}